#!/usr/bin/perl
# Client-Anwendung fuer Documation M200-PC-UC-Protokoll
# fuer Linux. Gibt Jones-Cardfile auf STDOUT aus.
# Sven, 18.03.2012

# ubuntu: libdevice-serialport-perl
use Device::SerialPort;
use Data::Dumper;
use strict;

$|++; # Disable output buffer (always a good idea)

sub construct_config {
	my $dev_file = "/dev/ttyS0";
	my $config_filename = "card-reader.cfg.txt";
	my $dev = new Device::SerialPort($dev_file) or die "Cannot open $dev_file: $!\n";

	$dev->baudrate(38400);
	$dev->databits(8);
	$dev->stopbits(1);
	$dev->handshake("none"); # oder "rts"

	print STDERR "Creating configuration for $dev_file to $config_filename\n";
	$dev->save($config_filename) or die "Could not write $config_filename: $!\n";
	return $config_filename;
}

my $conf_file = construct_config();
my $dev = tie(*READER, 'Device::SerialPort', $conf_file) or die "Cannot use $conf_file: $!\n";

print STDERR "Got it.\n";
$dev->write("h");

my $line = <READER>;
print "Line: $line\n";
exit;

while(<READER>) {
	print STDERR "Invalid line: '$_'\n" unless(/^\d{3}\s*(.+)\s*$/);
	my $cmd = $1;
	my $comment = $2;

	print STDERR "Fetched $cmd, with $comment\n";
}
